// TestProtocolApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TestProtocolApp.h"

#include "MainFrm.h"
#include "TestProtocolAppDoc.h"
#include "TestProtocolAppView.h"

#include <atlbase.h>

#include "..\DataProtocol\DataProtocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestProtocolAppApp

BEGIN_MESSAGE_MAP(CTestProtocolAppApp, CWinApp)
	//{{AFX_MSG_MAP(CTestProtocolAppApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestProtocolAppApp construction

CTestProtocolAppApp::CTestProtocolAppApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTestProtocolAppApp object

CTestProtocolAppApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTestProtocolAppApp initialization

BOOL CTestProtocolAppApp::InitInstance()
{
	AfxEnableControlContainer();

	HandleMyInternetProtocol(true);

	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CTestProtocolAppDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CTestProtocolAppView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTestProtocolAppApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTestProtocolAppApp message handlers

bool CTestProtocolAppApp::HandleMyInternetProtocol(bool bRegister)
{
	// Internet plugable protocol name
	// ,   -       ,
	//           .
	//      .
	static LPCWSTR pszPROT = L"myprot";

	static char chGetClassObjectName[] = "DllGetClassObject";
	typedef HRESULT (STDAPICALLTYPE  *GET_CLASS_OBJECT_PROC)(REFCLSID rclsid, REFIID riid, LPVOID* ppv);

	//   IInternetSession 
	CComPtr<IInternetSession> spIInetSession;
	if (FAILED(CoInternetGetSession( 0, &spIInetSession, 0 )))
		return false;
	// DLL     
	HMODULE hModule = LoadLibrary(_T("..\\..\\DataProtocol\\Debug\\DataProtocol.dll"));
	
	if (hModule == NULL)
		return false;

	// 
	GET_CLASS_OBJECT_PROC pfnDllGetClassObject;
	pfnDllGetClassObject = (GET_CLASS_OBJECT_PROC)GetProcAddress(hModule, chGetClassObjectName);
	if (pfnDllGetClassObject == NULL)
		return false;
	
	CComPtr <IClassFactory> spIClassFactory;
	HRESULT hr = (pfnDllGetClassObject)(__uuidof(DataPluggableProtocol), IID_IClassFactory , (void**)&spIClassFactory);
	if (FAILED(hr))
		return false;

	if (bRegister)
	{
		hr = spIInetSession->RegisterNameSpace(spIClassFactory, __uuidof(DataPluggableProtocol), pszPROT, 0, NULL, 0);
	}
	else
		hr = spIInetSession->UnregisterNameSpace(spIClassFactory, pszPROT);

	return SUCCEEDED(hr);
}


int CTestProtocolAppApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	HandleMyInternetProtocol(false);	

	return CWinApp::ExitInstance();
}
